"use strict";
// Copyright (c) TileDB, Inc.
// Distributed under the terms of the Modified BSD License.
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (Object.hasOwnProperty.call(mod, k)) result[k] = mod[k];
    result["default"] = mod;
    return result;
};
Object.defineProperty(exports, "__esModule", { value: true });
const base_1 = require("@jupyter-widgets/base");
const version_1 = require("./version");
const BABYLON = __importStar(require("@babylonjs/core"));
// Import the CSS
require("../css/widget.css");
class BabylonJSModel extends base_1.DOMWidgetModel {
    defaults() {
        return Object.assign({}, super.defaults(), { _model_name: BabylonJSModel.model_name, _model_module: BabylonJSModel.model_module, _model_module_version: BabylonJSModel.model_module_version, _view_name: BabylonJSModel.view_name, _view_module: BabylonJSModel.view_module, _view_module_version: BabylonJSModel.view_module_version, extents: [], query: null, value: null, token: '', uri: '', width: 700, height: 500, z_scale: 0.5 });
    }
}
BabylonJSModel.serializers = Object.assign({}, base_1.DOMWidgetModel.serializers);
BabylonJSModel.model_name = 'BabylonJSModel';
BabylonJSModel.model_module = version_1.MODULE_NAME;
BabylonJSModel.model_module_version = version_1.MODULE_VERSION;
BabylonJSModel.view_name = 'BabylonJSView';
BabylonJSModel.view_module = version_1.MODULE_NAME;
BabylonJSModel.view_module_version = version_1.MODULE_VERSION;
exports.BabylonJSModel = BabylonJSModel;
class BabylonJSView extends base_1.DOMWidgetView {
    render() {
        const loadingScreen = document.createElement('div');
        loadingScreen.id = 'loadingScreen';
        this.canvas = document.createElement('canvas');
        this.canvas.classList.add('renderCanvas');
        this.el.appendChild(this.canvas);
        this.model.on('change:query', this.query_changed, this);
        this.model.on_some_change(['width', 'height'], this.resizeCanvas, this);
        this.engine = new BABYLON.Engine(this.canvas, true);
        BABYLON.SceneLoader.ShowLoadingScreen = true;
        this.resizeCanvas();
        const scene = this.createScene();
        this.engine.runRenderLoop(function () {
            scene.render();
        });
    }
    createScene() {
        var scene = new BABYLON.Scene(this.engine);
        new BABYLON.PointLight("Point", new BABYLON.Vector3(5, 10, 5), scene);
        const camera = new BABYLON.ArcRotateCamera("Camera", 1, 0.8, 3, new BABYLON.Vector3(0, 0, 0), scene);
        camera.attachControl(this.canvas, true);
        const data = JSON.parse(this.model.get('value'));
        const extents = this.model.get('extents');
        const z_scale = this.model.get('z_scale');
        const num_coords = data.X.length;
        const minx = extents[0];
        const maxx = extents[1];
        const miny = extents[2];
        const maxy = extents[3];
        const minz = extents[4];
        const maxz = extents[5];
        const pcs = new BABYLON.PointsCloudSystem("pcs", 1, scene, { updatable: false });
        const myLoader = function (particle, i, s) {
            particle.position = new BABYLON.Vector3((data.X[i] - minx) / (maxx - minx), (data.Y[i] - miny) / (maxy - miny), ((data.Z[i] - minz) / (maxz - minz)) * z_scale);
            particle.color = new BABYLON.Color3(data.Red[i], data.Green[i], data.Blue[i]);
        };
        pcs.addPoints(num_coords, myLoader);
        pcs.buildMeshAsync();
        return scene;
    }
    ;
    resizeCanvas() {
        this.canvas.setAttribute('width', this.model.get('width'));
        this.canvas.setAttribute('height', this.model.get('height'));
        this.engine.resize();
    }
    query_changed() {
        // TODO
    }
}
exports.BabylonJSView = BabylonJSView;
//# sourceMappingURL=widget.js.map